/*

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

public class Blockmap
{
	Blockmap(int width, int height)
	{
		m_width = width;
		m_height = height;
		m_map = new int[m_width][m_height];
		clear();
	}
	
	public Blockmap duplicate()
	{
		Blockmap dup = new Blockmap(m_width, m_height);
		for(int j=0;j<m_height;j++)
			for(int i=0;i<m_width;i++)
				dup.set(i, j, m_map[i][j]);
				
		return dup;
	}
	
	public void clear()
	{
		for(int j=0;j<m_height;j++)
			for(int i=0;i<m_width;i++)
				m_map[i][j] = 0;
	}
	
	public void setValue(int value)
	{
		for(int j=0;j<m_height;j++)
			for(int i=0;i<m_width;i++)
				if(m_map[i][j] != 0)
					m_map[i][j] = value;
	}

	public void invertValue()
	{
		for(int j=0;j<m_height;j++)
			for(int i=0;i<m_width;i++)
				m_map[i][j] *= -1;
	}
		
	public void set(int x, int y, int value)
	{
		if(x >= 0 && y >= 0 && x < m_width && y < m_height)
		{
			m_map[x][y] = value;
		}
	}

	public int get(int x, int y)
	{
		if(x >= 0 && y >= 0 && x < m_width && y < m_height)
		{
			return m_map[x][y];
		}
		else
		{
			return -1;
		}
	}

	public int getWidth()
	{
		return m_width;
	}
		
	public int getHeight()
	{
		return m_height;
	}
	
	protected int[][] m_map;
	protected int m_width, m_height;
}
