/*

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

import java.applet.*;
import java.awt.*;
import java.awt.event.*;

public class TetrisApplet extends Applet
{
	public void init()
	{
		int blocksize = 25;
	
		setLayout(null);
		setBackground(Color.black);
		tetris = new Tetris(getBounds().width / blocksize, getBounds().height / blocksize, blocksize);
		add(tetris);
		tetris.setBounds(getBounds());
						
		MyKeyAdapter keyadapter = new MyKeyAdapter();
		addKeyListener(keyadapter);
		tetris.addKeyListener(keyadapter);
		
		tetris.start();
	}
	
	public void destroy()
	{
		tetris.stop();
	}
	
	protected Tetris tetris = null;
	
	private class MyKeyAdapter extends KeyAdapter
	{
		public void keyPressed(KeyEvent e)
		{
			switch(e.getKeyCode())
			{
			case KeyEvent.VK_LEFT:
				tetris.inputTranslateLeft();
				tetris.repaint();
				break;
			case KeyEvent.VK_RIGHT:
				tetris.inputTranslateRight();
				tetris.repaint();
				break;
			case KeyEvent.VK_UP:
				tetris.inputRotateLeft();
				tetris.repaint();
				break;
			case KeyEvent.VK_DOWN:
				tetris.inputRotateRight();
				tetris.repaint();
				break;
			case KeyEvent.VK_SPACE:
				tetris.inputWarp();
				tetris.repaint();
				break;
			case KeyEvent.VK_P:
				tetris.pause();
				tetris.repaint();
				break;
			case KeyEvent.VK_S:
				tetris.start();
				tetris.repaint();
				break;
			case KeyEvent.VK_ENTER:
				tetris.inputTranslateDown();
				tetris.repaint();
				break;
			};
		}
	}
}
